<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../../common/content-types';
import { channelPartnersService } from '../../../services/partners/channel-partners.service';
import { ChannelPartnersTable } from '~/components/partners/index.vue';
import { Hero, NextStepAlt } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  components: {
    Hero,
    ChannelPartnersTable,
    NextStepAlt,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData() {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'partners/channel-partners',
        include: 10,
      });
      const spaceId = response.items[0].sys.space.sys.id;
      const entryId = response.items[0].sys.id;
      const { pageContent } = response.items[0].fields;
      const seoMetadata = response.items[0].fields.seoMetadata[0].fields;

      const partner = channelPartnersService(pageContent);
      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };
      return { partner, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  nuxtI18n: false,

  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
});
</script>

<template>
  <section class="partners-container">
    <component
      :is="component.name"
      v-for="(component, index) in partner.components"
      :key="component.name + index"
      :data="component.data"
    />
    <NextStepAlt />
  </section>
</template>

<style lang="scss" scoped>
.partners-container {
  overflow-x: hidden;
  overflow-y: show;
}
</style>
